#ifndef __included_audio_analyzer_h
#define __included_audio_analyzer_h

namespace NK
{

class AudioAnalyzer
{
protected:
    int8_t const *samples;
    uint16_t nsamples;
    uint16_t zeroCrossings;
    uint32_t power;
    int8_t minValue;
    int8_t maxValue;
    bool analyzed;

    void analyze();

public:
    AudioAnalyzer(int8_t const *_samples, uint16_t _nsamples)
        : samples(_samples), nsamples(_nsamples), zeroCrossings(0), power(0), analyzed(false) {
    }

    uint16_t getZeroCrossings() {
        if (!analyzed) analyze();
        return zeroCrossings;
    }

    uint32_t getPower() {
        if (!analyzed) analyze();
        return power;
    }

    void getMinMaxValues(int8_t *min, int8_t *max) {
        if (!analyzed) analyze();
        *min = minValue;
        *max = maxValue;
    }
};

} // namespace NK
#endif